local ADDON_NAME = "ClearWaypoint"

local function OnAddonLoaded(event, name)
   if name == ADDON_NAME then
      EVENT_MANAGER:UnregisterForEvent(ADDON_NAME, event) 

      local PingMap_Orig = PingMap
      local RemovePlayerWaypoint_Orig = RemovePlayerWaypoint
      local activeWaypoint = false

      local function UnregisterUpdate()
         if activeWaypoint == true then
            EVENT_MANAGER:UnregisterForUpdate(ADDON_NAME)
            activeWaypoint = false
         end
      end

      function RemovePlayerWaypoint()
         UnregisterUpdate()
         RemovePlayerWaypoint_Orig()
      end 

      local function PingMap_Hook()
         local x, y = GetMapPlayerWaypoint()
         if (x ~= 0 and y ~= 0) then
            activeWaypoint = true
            EVENT_MANAGER:RegisterForUpdate(ADDON_NAME, 250, function()
               local locX, locY = GetMapPlayerPosition("player")
               if zo_floatsAreEqual(x, locX, 0.01) and zo_floatsAreEqual(y, locY, 0.01) then
                  --CENTER_SCREEN_ANNOUNCE:AddMessage(0, CSA_EVENT_SMALL_TEXT, SOUNDS.ACHIEVEMENT_AWARDED, "Destination reached")
                  RemovePlayerWaypoint()
               end 
            end)
         end
      end

      function PingMap(...)
         UnregisterUpdate()
         PingMap_Orig(...)
         PingMap_Hook()
      end

      PingMap_Hook()
   end
end

EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_ADD_ON_LOADED, OnAddonLoaded)
